#include<bits/stdc++.h>
using namespace std;

#define int long

const int MOD = 998244353, MAXN = 431, INF = 1e18;


signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int T;
    cin >> T;
    int n, m;
    cin >> n >> m;
    vector<int> pos(n);
    for(int i = 0; i < n; i++) cin >> pos[i];
    string s;
    cin >> s;
    if(m % 2 == 0){
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    if(m == 1){
        if(T >= 2) cout << 1 << "\n";
        if(T >= 3) cout << 0 << "\n";
        return 0;
    }
    if(T >= 2){
        cout << (pos[0] + pos[1]) / 2 << "\n";
    }
    if(T >= 3){
        cout << 1 << "\n";
        cout << (pos[0] + pos[1]) / 2 - 1 << " " << (pos[0] + pos[1]) / 2 << "\n";
    }
}